<html>
<head>
	<script src="https://cdn.plot.ly/plotly-latest.min.js"></script>
</head>
<body>
<div id="myDiv"></div>
</body>


<script>

Plotly.d3.csv('raw_data/new_data2.csv', function (err, data) {
  // Create a lookup table to sort and regroup the columns of data,
  // first by year, then by continent:
  var lookup = {};
  function getData(year, continent) {
    var byYear, trace;
    if (!(byYear = lookup[year])) {;
      byYear = lookup[year] = {};
    }
	 // If a container for this year + continent doesn't exist yet,
	 // then create one:
    if (!(trace = byYear[continent])) {
      trace = byYear[continent] = {
        x: [],
        y: [],
        id: [],
        text: [],
        joined: [],
        marker: {size: []}
      };
    }
    return trace;
  }

  // Go through each row, get the right trace, and append the data:

  for (var i = 0; i < data.length; i++) {
    var datum = data[i];
    var trace = getData(datum.year, datum.geo);
    trace.text.push(datum.geo);
    trace.id.push(datum.geo);
    //trace.x.push(parseFloat(datum.fossil_adjusted_values));
    trace.x.push(parseFloat(datum.values));
    trace.y.push(datum.gdp_per_capita);
    trace.joined.push(datum.joined);
    //trace.marker.size.push(datum.fossil_adjusted_values * 1000000);
    trace.marker.size.push(datum.values * 1000000);

  }

  // Get the group names:
  var years = Object.keys(lookup);

  continents = [];
  for (i = 0; i < data.length; i++){
    continents[i] = data[i]["geo"];
  }
  var continents = Array.from(new Set(continents));

  // In this case, every year includes every continent, so we
  // can just infer the continents from the *first* year:
  var firstYear = lookup[years[0]];

  //var continents = Object.keys(firstYear);


  // Create the main traces, one for each continent:
  var traces = [];
  for (i = 0; i < continents.length; i++) {
    var data = firstYear[continents[i]];
    var color = "lightgrey";
  
   
    if (data!=null){
      
      if(data.joined.slice() == "Estonia"){
        color = "blue";
      }
      if(data.joined.slice() == "EU"){
        color = "orange";
      }
      if(data.joined.slice() == "old"){
        color = "#9ecae9";
      }
      if(data.joined.slice() == "new"){
        color = "#8de87a";
      }
    	traces.push({
		      name: continents[i],
		      x: data.x.slice(),
		      y: data.y.slice(),
		      id: data.id.slice(),
		      text: data.text.slice(),
          textposition: "top",
          textfont: {
            color: color
          },

		      mode: 'markers+text+line',
		      //hoverinfo: 'text',


		      marker: {
		        size: data.marker.size.slice(),
            color: color,
		        sizemode: 'area',
		        sizeref: 20000,
		        opacity: 0.8
		      }
		    });
    } else{
    	traces.push({
		      name: continents[i],
		      x: 0,
		      y: 0,
		      id: continents[i],
		      text: "",
          textposition: "top",
          textfont: {
            color: color
          },
		      mode: 'markers+text',
		      marker: {
		        size: 0,
		        sizemode: 'area',
            color: color,
		        sizeref: 200000
		      }
		    });
    }


	 // One small note. We're creating a single trace here, to which
	 // the frames will pass data for the different years. It's
	 // subtle, but to avoid data reference problems, we'll slice
	 // the arrays to ensure we never write any new data into our
	 // lookup table:



  }


  // Create a frame for each year. Frames are effectively just
  // traces, except they don't need to contain the *full* trace
  // definition (for example, appearance). The frames just need
  // the parts the traces that change (here, the data).
  var frames = [];
  for (i = 0; i < years.length; i++) {
    frames.push({
      name: years[i],
      type: 'markers+text',
      data: continents.map(function (continent) {
        return getData(years[i], continent);
      })
    })
  }


  // Now create slider steps, one for each frame. The slider
  // executes a plotly.js API command (here, Plotly.animate).
  // In this example, we'll animate to one of the named frames
  // created in the above loop.
  var sliderSteps = [];
  for (i = 0; i < years.length; i++) {
    sliderSteps.push({
      method: 'animate',
      label: years[i],
      args: [[years[i]], {
        mode: 'immediate',
        transition: {duration: 1000},
        frame: {duration: 1000, redraw: true},
      }]
    });
  }

  var layout = {
  	width: 1300,
  	height: 800,
    showlegend: false,
    xaxis: {
      //title: 'Domestic material consumption (without fossil)',
      title: 'Domestic material consumption (tons per capita)',
      range: [0, 60],
      ticks: 'outside',

    },
    yaxis: {
    	//range: [0, 0.1],
      title: 'GDP per capita',
      type: 'log',
      ticks: 'outside'

    },

    hovermode: 'closest',

	 // We'll use updatemenus (whose functionality includes menus as
	 // well as buttons) to create a play button and a pause button.
	 // The play button works by passing `null`, which indicates that
	 // Plotly should animate all frames. The pause button works by
	 // passing `[null]`, which indicates we'd like to interrupt any
	 // currently running animations with a new list of frames. Here
	 // The new list of frames is empty, so it halts the animation.
    updatemenus: [{
      x: 0,
      y: 0,
      yanchor: 'top',
      xanchor: 'left',
      showactive: false,
      direction: 'left',
      type: 'buttons',
      pad: {t: 87, r: 10},
      buttons: [{
        method: 'animate',
        args: [null, {
          mode: 'immediate',
          fromcurrent: true,
          transition: {duration: 1000, easing: 'cubic-in-out'},
          frame: {duration: 1000, redraw: false}
        }],
        label: 'Play'
      }, {
        method: 'animate',
        args: [[null], {
          mode: 'immediate',
          transition: {duration: 0},
          frame: {duration: 0, redraw: false}
        }],
        label: 'Pause'
      }]
    }],
	 // Finally, add the slider and use `pad` to position it
	 // nicely next to the buttons.
    sliders: [{
      pad: {l: 130, t: 85},
      currentvalue: {
        visible: true,
        prefix: 'Year:',
        xanchor: 'right',
        font: {size: 20, color: '#666'}
      },
      steps: sliderSteps
    }]
  };

  // Create the plot:
  Plotly.plot('myDiv', {
    data: traces,
    layout: layout,
    frames: frames,
  });
});
</script>
</html>
